head	1.2;
access;
symbols;
locks; strict;
comment	@ * @;


1.2
date	2003.03.26.15.17.47;	author lefevre;	state Exp;
branches;
next	1.1;

1.1
date	2003.03.26.14.13.09;	author lefevre;	state Exp;
branches;
next	;


desc
@Joint des fichiers gnrs par dagsearch avec -DSHIFTS.
@


1.2
log
@Programme termin.
@
text
@/*
 * $Id: dsjoin.c 1.1 2003/03/26 14:13:09 lefevre Exp lefevre $
 *
 * See usage below.
 *
 * Joins files generated by dagsearch with -DSHIFTS. This is useful
 * when searches have been performed in parallel on different DAGS,
 * or when the searches had to be interrupted and resumed later on
 * the remaining DAGS.
 */

#include <stdio.h>
#include <stdlib.h>

#define USAGE \
  "Usage: dsjoin <cost.in1> <cinf.in1> <csup.in1> <code.in1> <dags.in1>\n" \
  "              <cost.in2> <cinf.in2> <csup.in2> <code.in2> <dags.in2>\n" \
  "              <cost.out> <cinf.out> <csup.out> <code.out> <dags.out>\n"

static FILE *f[3][5];
static int cin[2][3];
static int nd[2] = { 0, 0 };
static unsigned long n = 0;

static int nextc(void)
{
  int i, j;
  int ok;

  for (i = 0; i < 2; i++)
    for (j = 0; j < 3; j++)
      {
        int c;
        c = getc(f[i][j]);
        if (i == 0 && j == 0)
          ok = (c != EOF);
        else if ((c != EOF) != ok)
          {
            fprintf(stderr, "dsjoin: unexpected end of file\n");
            exit(3);
          }
        if (ok)
          cin[i][j] = c;
      }
  return ok;
}

static void wrtc(int c, int j)
{
  if (putc(c, f[2][j]) == EOF)
    {
      fprintf(stderr, "dsjoin: can't write to file %d\n", j);
      exit(4);
    }
}

static void copycode(int i)
{
  unsigned char buffer[8];
  unsigned int dagnumber;

  if ((n & 1) == 0)
    return;

  if (fread(buffer, 8, 1, f[1-i][3]) != 1 ||
      fread(buffer, 8, 1, f[i][3]) != 1)
    {
      fprintf(stderr, "dsjoin: fread failed!\n");
      exit(6);
    }

  if (n > 1)
    {
      dagnumber = (unsigned int) buffer[0]
        + ((unsigned int) buffer[1] << 8);
      if (dagnumber < 1 || dagnumber > nd[i])
        {
          fprintf(stderr,
                  "dsjoin: dagnumber out of range\n"
                  "  n = %lu\n"
                  "  i = %d\n"
                  "  dagnumber = %u\n",
                  n, i, dagnumber);
          exit(10);
        }
      if (i == 1)
        {
          dagnumber += nd[0];
          buffer[0] = (unsigned char) dagnumber;
          buffer[1] = (unsigned char) (dagnumber >> 8);
        }
    }

  if (fwrite(buffer, 8, 1, f[2][3]) != 1)
    {
      fprintf(stderr, "dsjoin: fwrite failed!\n");
      exit(7);
    }
}

static void join(void)
{
  if (cin[0][0] == cin[1][0])
    {
      int i;

      wrtc(cin[0][0], 0);
      i = cin[0][1] > cin[1][1];
      wrtc(cin[i][1], 1);
      copycode(i);
      i = cin[0][2] < cin[1][2];
      wrtc(cin[i][2], 2);
      copycode(i);
    }
  else
    {
      int i, j;

      i = cin[0][0] > cin[1][0];
      for (j = 0; j < 3; j++)
        wrtc(cin[i][j], j);
      copycode(i);
      copycode(i);
    }

  n++;
}

int main(int argc, char **argv)
{
  int i, j, k;

  if (argc != 16)
    {
      fprintf(stderr, USAGE);
      exit(1);
    }

  k = 0;
  for (i = 0; i < 3; i++)
    for (j = 0; j < 5; j++)
      {
        FILE *p;
        p = fopen(argv[++k], i == 2 ? "wb" : "rb");
        if (p == NULL)
          {
            fprintf(stderr, "dsjoin: can't open file %s\n", argv[k]);
            exit(2);
          }
        f[i][j] = p;
      }

  for (i = 0; i < 2; i++)
    {
      char buffer[128];

      buffer[(sizeof buffer) - 1] = '*';  /* marker */
      while (fgets(buffer, sizeof buffer, f[i][4]))
        {
          if (buffer[(sizeof buffer) - 1] == '\0')
            {
              fprintf(stderr, "dsjoin: buffer too small\n");
              exit(8);
            }
          if (fputs(buffer, f[2][4]) == EOF)
            {
              fprintf(stderr, "dsjoin: fputs failed!\n");
              exit(9);
            }
          nd[i]++;
        }
    }

  while (nextc())
    join();

  k = 0;
  for (i = 0; i < 3; i++)
    for (j = 0; j < 4; j++)
      if (fclose(f[i][j]))
        {
          fprintf(stderr, "dsjoin: can't close file %s\n", argv[k]);
          exit(5);
        }

  return 0;
}
@


1.1
log
@Initial revision
@
text
@d2 1
a2 1
 * $Id$
d4 1
a4 3
 * Usage: dsjoin <cost.in1> <cinf.in1> <csup.in1> <code.in1>
 *               <cost.in2> <cinf.in2> <csup.in2> <code.in2>
 *               <cost.out> <cinf.out> <csup.out> <code.out>
d15 6
a20 1
static FILE *f[3][4];
d22 2
a23 1
static int odd = 0;
d60 1
d62 1
a62 1
  if (!odd)
d71 23
d126 1
a126 1
  odd = !odd;
d133 1
a133 1
  if (argc != 13)
d135 1
a135 4
      fprintf(stderr,
              "Usage: dsjoin <cost.in1> <cinf.in1> <csup.in1> <code.in1>\n"
              "              <cost.in2> <cinf.in2> <csup.in2> <code.in2>\n"
              "              <cost.out> <cinf.out> <csup.out> <code.out>\n");
d141 1
a141 1
    for (j = 0; j < 4; j++)
d153 21
d182 1
a182 1
          fprintf(stderr, "dsjoin: can't open file %s\n", argv[k]);
@
