head	1.17;
access;
symbols;
locks; strict;
comment	@ * @;


1.17
date	2001.02.28.17.31.32;	author lefevre;	state Exp;
branches;
next	1.16;

1.16
date	2001.02.28.14.10.44;	author lefevre;	state Exp;
branches;
next	1.15;

1.15
date	2001.02.27.11.00.59;	author lefevre;	state Exp;
branches;
next	1.14;

1.14
date	2001.02.26.13.25.15;	author lefevre;	state Exp;
branches;
next	1.13;

1.13
date	2001.02.26.12.49.53;	author lefevre;	state Exp;
branches;
next	1.12;

1.12
date	2001.02.26.10.46.01;	author lefevre;	state Exp;
branches;
next	1.11;

1.11
date	2001.02.02.14.34.02;	author lefevre;	state Exp;
branches;
next	1.10;

1.10
date	2001.02.02.14.17.52;	author lefevre;	state Exp;
branches;
next	1.9;

1.9
date	2001.02.02.13.30.50;	author lefevre;	state Exp;
branches;
next	1.8;

1.8
date	2001.02.01.13.22.07;	author lefevre;	state Exp;
branches;
next	1.7;

1.7
date	2001.02.01.13.10.47;	author lefevre;	state Exp;
branches;
next	1.6;

1.6
date	2001.02.01.12.56.33;	author lefevre;	state Exp;
branches;
next	1.5;

1.5
date	2001.02.01.10.47.03;	author lefevre;	state Exp;
branches;
next	1.4;

1.4
date	2001.01.21.01.28.58;	author lefevre;	state Exp;
branches;
next	1.3;

1.3
date	2001.01.18.16.41.45;	author lefevre;	state Exp;
branches;
next	1.2;

1.2
date	2001.01.18.15.48.24;	author lefevre;	state Exp;
branches;
next	1.1;

1.1
date	2001.01.18.15.21.00;	author lefevre;	state Exp;
branches;
next	;


desc
@Multiplication par une constante: calcul de majorants du cot optimal
@


1.17
log
@Ajout d'un fflush.
@
text
@/*
 * $Id: qtree.c 1.16 2001/02/28 14:10:44 lefevre Exp lefevre $
 *
 * Calculate f_m(n): [[-m,+m]] -> N such that
 *   1) f_m(n) = 0 for n in E = {0, +2^k, -2^k}, k integer
 *   2) f_m(a+b) <= f_m(a) + f_m(b) + 1
 *   3) f_m(ab) <= f_m(a) + f_m(b)
 *   4) for each n not in E, there exist a and b such that
 *        _ n = a+b and (2) is an equality, or
 *        _ n = ab with |a| > 1 and |b| > 1, and (3) is an equality.
 *
 * Compile options:
 *   -DPARENTS   save the parents a and b in the structure (not useful
 *               for the moment)
 *   -DRESULTS   write information to stdout each time a value is found
 *   -DLOWMEM    low memory (--> PARENTS is undefined)
 *
 * Usage: qtree <cmax> <m> [[-]<dest_file>]
 *   cmax: maximal cost (-1 if no maximal cost)
 *   m: value of m (decimal number)
 *   dest_file: if present, file where the values of f_m are stored
 *   -dest_file: the file is saved at each iteration
 */

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

#ifdef LOWMEM

#undef PARENTS

#define COST(X) t[X]

#define FRST(X) X = first[c##X], v##X = u[c##X]

#define NEXT(X) do { \
    long k; \
    k = *(v##X++); \
    if (k && COST(X+k) == c##X) \
      X += k; \
    else \
    { \
      k += *(v##X++) << 8; \
      if (k && COST(X+k) == c##X) \
        X += k; \
      else \
      { \
        k += *(v##X++) << 16; \
        if (k && COST(X+k) == c##X) \
          X += k; \
        else \
        { \
          k += *(v##X++) << 24; \
          if (k) \
            X += k; \
          else \
            X = -1; \
        } \
      } \
    } \
  } while (0)

#define SETNEXT(X,V)

static size_t setu0(char *t, char *z, unsigned char *v)
{
  size_t s = 4;
  long d = 0;
  int c;

  c = *t;
  while (++d, ++t <= z)
    if (*t == c)
      for (; d; d >>= 8)
      {
        s++;
        if (v)
          *(v++) = (unsigned char) d;
      }
  if (v)
    v[0] = v[1] = v[2] = v[3] = 0;
  return s;
}

static void setu(char *t, char *z, unsigned char **u)
{
  unsigned long s;
  s = setu0(t, z, NULL);
  printf("Memory requested: %lu bytes\n", s);
  fflush(stdout);
  *u = malloc(s);
  if (*u == NULL)
  {
    fprintf(stderr, "qtree: out of memory!\n");
    exit(7);
  }
  (void) setu0(t, z, *u);
}

#else

#define COST(X) t[X].cost
#define FRST(X) X = first[c##X]
#define NEXT(X) X = t[X].next
#define SETNEXT(X,V) t[X].next = V

#endif

#ifdef PARENTS
#define ADDPARENTS(A, B) \
  t[n].a = (A); \
  t[n].b = (B);
#else
#define ADDPARENTS(A, B)
#endif

#define VALID(A, B) do { \
    COST(n) = c; \
    ADDPARENTS(A, B) \
    if (n < nmin) nmin = n; \
    r--; \
  } while (0)

#ifdef RESULTS

#define EMIT(a, b, n, c, o) emit(a, b, n, c, o)

static void emit(long a, long b, long n, int c, int o)
{
  printf("Cost %d: %8ld %c %8ld -> %8ld\n", c, a, o, b, n);
}

#else

#define EMIT(a, b, n, c, o)

#endif

#ifdef LOWMEM

typedef signed char CELL;
CELL cost;

#else

struct cell
{
  int cost;
#ifdef PARENTS
  long a, b;
#endif
  long next;
};

typedef struct cell CELL;

#endif

#define WRITEFILE do { \
    for (i = 0; i <= m; i++) \
    { \
      if (COST(i) > 126) \
      { \
        fprintf(stderr, "qtree: cost too high!\n"); \
        exit(33); \
      } \
      if (putc(COST(i), f) < 0) \
      { \
        fprintf(stderr, "qtree: cannot write to file!\n"); \
        exit(34); \
      } \
    } \
    if (fclose(f)) \
    { \
      fprintf(stderr, "qtree: cannot close file!\n"); \
      exit(35); \
    } \
  } while (0)

int main(int argc, char **argv)
{
  int flag = -1;   /* -1: results not saved;
                       0: results saved at each iteration;
                       1: results saved at the end */
  char *file = NULL;
  long h, i, m, r;
  int c, cmax;
  CELL *t;
  long *first;

#ifdef LOWMEM
  unsigned char **u;
#endif

  if (argc != 3 && argc != 4)
  {
    usage: fprintf(stderr, "Usage: qtree <cmax> <m> [[-]<dest_file>]\n");
    exit(1);
  }

  cmax = atoi(argv[1]);
  if (cmax < 0)
    printf("No maximal cost\n");
  else
    printf("Maximal cost: %d\n", cmax);

  m = atol(argv[2]);
  if (m < 1)
  {
    fprintf(stderr, "qtree: m must be at least 1\n");
    exit(2);
  }

  if (m >= (1UL << 31) || m >= LONG_MAX / sizeof(CELL) - 1)
  {
    fprintf(stderr, "qtree: m too large\n");
    exit(3);
  }

  t = malloc((m+1) * sizeof(CELL));
  if (t == NULL)
  {
    fprintf(stderr, "qtree: out of memory!\n");
    exit(4);
  }

  if (argc == 4)
  {
    file = argv[3];
    flag = file[0] != '-';
    if (!flag && *(++file) == '\0')
      goto usage;
    printf(flag ? "Results saved at the end\n"
                : "Results saved at each iteration\n");
  }
  else
    file = NULL;  /* to avoid the warning with gcc 2.95.2 */

  for (i = 2; i <= m; i++)
    COST(i) = -1;  /* not valid yet */

  COST(0) = 0;
  r = m;  /* number of unitialized cells */
  for (h = 0, i = 1, c = 0; i <= m; h = i, i <<= 1, c++)
  {
    COST(i) = 0;
    SETNEXT(h,i);
    r--;
  }
  SETNEXT(h,-1);  /* last element in list */

  first = malloc(c * sizeof(*first));
  if (first == NULL)
  {
    fprintf(stderr, "qtree: out of memory!\n");
    exit(5);
  }
  first[0] = 0;

#ifdef LOWMEM
  u = malloc(c * sizeof(*u));
  if (u == NULL)
  {
    fprintf(stderr, "qtree: out of memory!\n");
    exit(6);
  }
  setu(t, t + m, u);
#endif

  for (c = 1; r && (cmax < 0 || c <= cmax); c++)
  {
    /* find all the positive integers n such that f_m(n) = c */

    long nmin = LONG_MAX;
    long a, b;
    int ca, cb;

#ifdef LOWMEM
    unsigned char *va, *vb;
#else
    long next;
#endif

    for (ca = 0, cb = c - 1 - ca; cb >= ca; ca++, cb--)
      for (FRST(a); a >= 0;)
      { /* loop a */

        FRST(b);

        while ((unsigned long) b < a)
        { /* loop b1 */
          long n;

          n = a+b;
          if (n <= m && COST(n) < 0)
          {
            EMIT(a, b, n, c, '+');
            VALID(a, b);
          }

          n = a-b;
          if (COST(n) < 0)
          {
            EMIT(a, b, n, c, '-');
            VALID(a, -b);
          }

          NEXT(b);
        } /* loop b1 */

        while (b >= 0)
        { /* loop b2 */
          long n;

          n = a+b;
          if (n > m) break;
          if (COST(n) < 0)
          {
            EMIT(a, b, n, c, '+');
            VALID(a, b);
          }

          n = b-a;
          if (COST(n) < 0)
          {
            EMIT(a, b, n, c, '-');
            VALID(a, -b);
          }

          NEXT(b);
        } /* loop b2 */

        while (b >= 0)
        { /* loop b3 */
          long n;

          n = b-a;
          if (COST(n) < 0)
          {
            EMIT(a, b, n, c, '-');
            VALID(a, -b);
          }

          NEXT(b);
        } /* loop b3 */

        NEXT(a);
      } /* loop a */

    for (ca = 1, cb = c - ca; cb >= ca; ca++, cb--)
      for (FRST(a); a >= 0;)
      {
        for (FRST(b); b >= 0;)
        {
          unsigned long long n;
          n = (unsigned long long) a * (unsigned long long) b;
          if (n > m) break;
          if (COST(n) < 0)
          {
            EMIT(a, b, (long) n, c, '*');
            VALID(-a, b);
          }
          NEXT(b);
        }
        NEXT(a);
      }

    for (b = 3; b <= m; b++)
      if (COST(b) == c && (b & 1 || COST(b>>1) != c))
    {
      unsigned long n;
      for (n = b, a = 2; (n <<= 1) <= m; a <<= 1)
        if (COST(n) < 0)
        {
          EMIT(a, b, n, c, '*');
          VALID(-a, b);
        }
    }

    first[c] = nmin;

#ifdef LOWMEM
    setu(t + nmin, t + m, u + c);
#else
    next = nmin;
    for (b = next; b <= m; b++)
      if (COST(b) == c)
      {
        SETNEXT(next,b);
        next = b;
      }
    SETNEXT(next,-1);
#endif

    printf("Nmin(%d) = %ld\n", c, nmin);
    fflush(stdout);

    if (flag == 0)  /* temporary results */
    {
      FILE *f;

      f = fopen(file, "r+b");
      if (f == NULL)
      {
        f = fopen(file, "wb");
        if (f == NULL)
        {
          fprintf(stderr, "qtree: cannot open file (update or create)!\n");
          exit(32);
        }
      }
      WRITEFILE;
    }
  }

  if (flag == 1)  /* final results */
  {
    FILE *f;

    f = fopen(file, "wb");
    if (f == NULL)
    {
      fprintf(stderr, "qtree: cannot create file!\n");
      exit(32);
    }
    WRITEFILE;
  }

  return 0;
}
@


1.16
log
@Les rsultats peuvent tre sauvs  chaque itration.
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.15 2001/02/27 11:00:59 lefevre Exp lefevre $
d91 1
@


1.15
log
@Option -DLOWMEM: info sur la mmoire demande pour les listes chanes.
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.14 2001/02/26 13:25:15 lefevre Exp lefevre $
d18 1
a18 1
 * Usage: qtree <cmax> <m> [<dest_file>]
d22 1
d159 21
d182 4
d197 1
a197 1
    fprintf(stderr, "Usage: qtree <cmax> <m> [<dest_file>]\n");
d227 12
d397 17
d416 1
a416 1
  if (argc == 4)
d420 1
a420 1
    f = fopen(argv[3], "wb");
d424 1
a424 19
      exit(6);
    }
    for (i = 0; i <= m; i++)
    {
      if (COST(i) > 126)
      {
        fprintf(stderr, "qtree: cost too high!\n");
        exit(7);
      }
      if (putc(COST(i), f) < 0)
      {
        fprintf(stderr, "qtree: cannot write to file!\n");
        exit(8);
      }
    }
    if (fclose(f))
    {
      fprintf(stderr, "qtree: cannot close file!\n");
      exit(9);
d426 1
@


1.14
log
@Bug corrig (pour l'option -DLOWMEM).
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.13 2001/02/26 12:49:53 lefevre Exp lefevre $
d87 4
a90 1
  *u = malloc(setu0(t, z, NULL));
@


1.13
log
@Casts inutiles retirs.
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.12 2001/02/26 10:46:01 lefevre Exp lefevre $
d238 1
a238 1
    char *va, *vb;
@


1.12
log
@Option -DLOWMEM.
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.11 2001/02/02 14:34:02 lefevre Exp lefevre $
d226 1
a226 1
  setu((char *) t, (char *) t + m, u);
d342 1
a342 1
    setu((char *) t + nmin, (char *) t + m, u + c);
@


1.11
log
@Optimisation: droulement de boucles.
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.10 2001/02/02 14:17:52 lefevre Exp lefevre $
d16 1
d28 77
d114 5
a118 5
  t[n].cost = c; \
  ADDPARENTS(A, B) \
  if (n < nmin) nmin = n; \
  r--; \
  } while (0) \
d124 1
a124 1
void emit(long a, long b, long n, int c, int o)
d135 7
d153 2
d162 4
d199 1
a199 1
    t[i].cost = -1;  /* not valid yet */
d201 1
a201 1
  t[0].cost = 0;
d205 2
a206 2
    t[i].cost = 0;
    t[h].next = i;
d209 1
a209 1
  t[h].next = -1;  /* last element in list */
d219 10
a232 1
    long next;
d237 6
d244 7
a250 4
      for (a = first[ca]; a >= 0; a = t[a].next)
      {
        for (b = first[cb]; (unsigned long) b < a; b = t[b].next)
        { /* loop 1 */
d254 1
a254 1
          if (n <= m && t[n].cost < 0)
d261 1
a261 1
          if (t[n].cost < 0)
a265 1
        } /* loop 1 */
d267 5
a271 2
        for (; b >= 0; b = t[b].next)
        { /* loop 2 */
d276 1
a276 1
          if (t[n].cost < 0)
d283 1
a283 1
          if (t[n].cost < 0)
a287 1
        } /* loop 2 */
d289 5
a293 2
        for (; b >= 0; b = t[b].next)
        { /* loop 3 */
d297 1
a297 1
          if (t[n].cost < 0)
d301 7
a307 3
          } /* loop 3 */
        }
      }
d310 3
a312 2
      for (a = first[ca]; a >= 0; a = t[a].next)
        for (b = first[cb]; b >= 0; b = t[b].next)
d317 1
a317 1
          if (t[n].cost < 0)
d322 1
d324 2
d328 1
a328 1
      if (t[b].cost == c && (b & 1 || t[b>>1].cost != c))
d332 1
a332 1
        if (t[n].cost < 0)
d339 6
a344 1
    first[c] = next = nmin;
d346 1
a346 1
      if (t[b].cost == c)
d348 1
a348 1
        t[next].next = b;
d351 3
a353 1
    t[next].next = -1;
d370 1
a370 1
      if (t[i].cost > 255)
d375 1
a375 1
      if (putc(t[i].cost, f) < 0)
@


1.10
log
@Option -DSORT retire --> tri toujours effectu.
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.9 2001/02/02 13:30:50 lefevre Exp lefevre $
d139 3
a141 2
        for (b = first[cb]; b >= 0; b = t[b].next)
        {
d151 22
a172 2
          n = abs(a-b);
          if (n <= m && t[n].cost < 0)
d177 12
d190 1
@


1.9
log
@Optimisation pour viter un grand nombre de multiplications (avec SORT).
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.8 2001/02/01 13:22:07 lefevre Exp lefevre $
a15 1
 *   -DSORT      sort the linked lists (should be faster)
a34 8
#ifdef SORT
#define ADDNEXT
#else
#define ADDNEXT \
  t[n].next = next; \
  next = n;
#endif

a37 1
  ADDNEXT \
a136 4
#ifndef SORT
    next = -1;
#endif

a163 1
#ifdef SORT
a165 3
#else
          if (n <= m && t[n].cost < 0)
#endif
a171 1
#ifdef SORT
a173 3
#else
    for (b = next; b >= 0; b = t[b].next)
#endif
d184 1
a184 5
#ifdef SORT
    next = nmin;
#endif
    first[c] = next;
#ifdef SORT
a191 1
#endif
@


1.8
log
@Optimisation: possibilit de donner un cot maximal.
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.7 2001/02/01 13:10:47 lefevre Exp lefevre $
d178 4
d183 1
@


1.7
log
@Flush pour les rsultats concernant nmin.
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.6 2001/02/01 12:56:33 lefevre Exp lefevre $
d18 2
a19 1
 * Usage: qtree <m> [<dest_file>]
d81 1
a81 1
  int c;
d85 1
a85 1
  if (argc != 2 && argc != 3)
d87 1
a87 1
    fprintf(stderr, "Usage: qtree <m> [<dest_file>]\n");
d91 7
a97 1
  m = atol(argv[1]);
d138 1
a138 1
  for (c = 1; r; c++)
d218 1
a218 1
  if (argc == 3)
d222 1
a222 1
    f = fopen(argv[2], "wb");
@


1.6
log
@Optimisation: tri des listes chanes (optionnel).
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.5 2001/02/01 10:47:03 lefevre Exp lefevre $
d208 1
@


1.5
log
@Commentaires: options de compilation et usage.
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.4 2001/01/21 01:28:58 lefevre Exp lefevre $
d16 1
d35 8
d46 1
a46 2
  t[n].next = next; \
  next = n; \
d135 1
a135 1
    long next = -1;
d140 4
d178 4
d183 1
d194 3
d198 9
@


1.4
log
@Sauvegarde optionnelle des cots dans un fichier.
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.3 2001/01/18 16:41:45 lefevre Exp lefevre $
d11 9
@


1.3
log
@Optimisation: calcul des parents que si PARENTS est dfini.
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.2 2001/01/18 15:48:24 lefevre Exp lefevre $
d67 1
a67 1
  if (argc != 2)
d69 1
a69 1
    fprintf(stderr, "Usage: qtree <m>\n");
d170 30
@


1.2
log
@Calcul de Nmin.
@
text
@d2 1
a2 1
 * $Id: qtree.c 1.1 2001/01/18 15:21:00 lefevre Exp lefevre $
d17 8
d27 1
a27 2
  t[n].a = (A); \
  t[n].b = (B); \
d52 1
d54 1
@


1.1
log
@Initial revision
@
text
@d2 1
a2 1
 * $Id$
d17 10
d110 1
d124 1
a124 6
            t[n].cost = c;
            t[n].a = a;
            t[n].b = b;
            t[n].next = next;
            next = n;
            r--;
d131 1
a131 6
            t[n].cost = c;
            t[n].a = a;
            t[n].b = -b;
            t[n].next = next;
            next = n;
            r--;
d144 1
a144 6
            t[n].cost = c;
            t[n].a = -a;
            t[n].b = b;
            t[n].next = next;
            next = n;
            r--;
d155 1
a155 6
          t[n].cost = c;
          t[n].a = -a;
          t[n].b = b;
          t[n].next = next;
          next = n;
          r--;
d160 1
@
