/*
 * $Id: readcost.c 1.4 2002/12/31 16:48:08 lefevre Exp $
 *
 * Read the costs generated by qtree (or similar programs).
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

int main(int argc, char **argv)
{
  FILE *f;
  int i;

  if (argc < 2)
    {
      fprintf(stderr, "Usage: readcost <file> [ <n> ... ]\n");
      exit(1);
    }

  f = fopen(argv[1], "rb");
  if (f == NULL)
    {
      fprintf(stderr, "readcost: cannot open file %s\n", argv[1]);
      exit(2);
    }

  for (i = 2; i < argc; i++)
    {
      long int n;
      char *end;
      int c;

      n = strtol(argv[i], &end, 0);
      if (*end != '\0' || errno == ERANGE || n < 0)
        {
          fprintf(stderr, "readcost: bad value %s\n", argv[i]);
          exit(3);
        }
      if (fseek(f, n, SEEK_SET))
        {
          fprintf(stderr, "readcost: fseek failed!\n");
          exit(4);
        }
      c = getc(f);
      if (c == EOF)
        {
          fprintf(stderr, "readcost: value %ld is too large\n", n);
          exit(5);
        }
      if (c == 255)
        printf("Cost(%ld) undefined\n", n);
      else
        printf("Cost(%ld) = %d\n", n, c);
    }

  return 0;
}
