/*
 * $Id: sumcosts.c 1.3 2001/02/06 12:43:09 lefevre Exp $
 *
 * Sum the costs generated by qtree (or similar programs).
 *
 */

#include <stdio.h>
#include <stdlib.h>

int get_next(FILE *f)
{
  int ch;

  ch = getc(f);
  if (ch != EOF)
  {
    ch = getc(f);
#if EOF == -1    /* useful because gcc can't optimize... */
    if ((unsigned char) ch != 255)
#else
    if (ch != EOF && ch != 255)
#endif
      return ch;
  }
  fclose(f);
  exit(0);
}

int main(int argc, char **argv)
{
  FILE *f;
  int m;
  long n;

  if (argc != 2)
  {
    fprintf(stderr, "Usage: sumcosts <file>\n");
    exit(1);
  }

  f = fopen(argv[1], "rb");
  if (f == NULL)
  {
    fprintf(stderr, "sumcosts: cannot open file!\n");
    exit(2);
  }

  get_next(f);

  m = 2;
  n = 1;
  while (1)
  {
    unsigned long s = 0;
    long i;

    for (i = n; i; i--)
      s += get_next(f);

    printf("m = %d, qav = %lu / 2^%d\n", m, s, m-2);
    m++;
    n <<= 1;
  }
}
